/*
### handle function key events  ###
*/

#include <suntool/sunview.h>

void handle_function_keys(mode,e_id)
int mode,e_id;
{
	int i, error_result;
	extern int model,func_on,func_on_old;
	extern int record_on,cur_color,region_index,clipping,show_error_mess,text_input_mode,more_digits_on;
	extern int mdim1,mdim1_init;
	extern int n_stored_data1,n_stored_data0,n_stored_data0_save,n_stored_data1_save;
	extern int var_dim,func_dim,param_dim,full_dim;
	extern int aux_max,*aux_on,aux_win_i;
	extern double *win_var_i,*win_var_f,*all_min,*all_max,*all_min_top,*all_max_top;

	/* FUNCTION KEYS */
	if(e_id == KEY_TOP(1) ){
		all_reset();
		clipping=1-clipping;
		if(clipping==1){
			system_mess_proc(0, "Clipping On");
		}
		else {
			system_mess_proc(0, "Clipping Off");
		}
		return;
	}
	if(e_id == KEY_TOP(2) ){
		all_reset();
		show_error_mess=1-show_error_mess;
		if(show_error_mess ==1){
			system_mess_proc(0, "Alert On");
		}
		else {
			system_mess_proc(0, "Alert Off");
		}
	}
	if(e_id == KEY_TOP(3) ){
		all_reset();
		error_result = (int) error_mess_proc("Reset panel values with current position?","Yes","No");
		
		if(error_result==1) {
			for(i=0;i<var_dim;i++){
				win_var_i[i]=win_var_f[i];
			}
			all_refresh();
		}
		return;
	}
	if(e_id == KEY_TOP(4) ){
		error_result = (int) error_mess_proc("Recover parameter window data?","Yes","No");
		if(error_result==1) {
			n_stored_data0 = n_stored_data0_save;
			redisplay_data(0);
			all_refresh();
		}
		return;
	}
	if(e_id == KEY_TOP(5) ){
		error_result = (int) error_mess_proc("Recover variable window data?","Yes","No");
		if(error_result==1) {
			n_stored_data1 = n_stored_data1_save;
			redisplay_data(1);
			all_refresh();
		}
		return;
	}
	/*
	if(e_id == KEY_TOP(6) ){
		print_option++;
		if(print_option==2)
			print_option=0;
		if(print_option==0)
			system_mess_proc(0,"New print option: Big, verbose figure mode!");
		else
			system_mess_proc(0,"New print option: Publication quality figure mode!");
	}
	*/
	if(e_id == KEY_TOP(7) ){
		more_digits_on = 1 - more_digits_on;
		if(more_digits_on){
			error_result = (int) error_mess_proc("Show more digits in panel text items?\n","Confirm","No");
		}
		else {
			error_result = (int) error_mess_proc("Show less digits in panel text items?\n","Confirm","No");
		}
		if(!error_result){
			more_digits_on = 1 - more_digits_on;
			(void) recreate_all_panels();
		}
		return;
	}
	if(e_id == KEY_TOP(8) ){
		all_reset();
		error_result = (int) error_mess_proc("Reset top-window with the current values?","Yes","No");
		if(error_result==1) {
			for(i=0;i<full_dim+param_dim;i++){
				all_min_top[i]=all_min[i];
				all_max_top[i]=all_max[i];
			}
		}
		return;
	}
	if(e_id == KEY_TOP(9) ){
		all_reset();
		if(!func_on)
			error_result = (int) error_mess_proc("Turn on Function variables?","Yes","No");
		else
			error_result = (int) error_mess_proc("Turn off Function variables?","Yes","No");
		if(error_result==1) {
			func_on_old = func_on;
			func_on = 1- func_on;
			(void) func_init();
			reset_panels();
		}
		return;
	}
	if(e_id == KEY_TOP(10) ){
		all_reset();
		record_on =1-record_on;
		if(record_on==1){
			system_mess_proc(0, "Recording On");
		}
		else {
			system_mess_proc(0, "Recording Off");
		}
		return;
	}
	if(e_id == KEY_TOP(11) ){
		all_reset();
		text_input_mode =1-text_input_mode;
		if(text_input_mode==1){
			system_mess_proc(0, "Text Input On");
		}
		else {
			system_mess_proc(0, "Text Input Off");
		}
		return;
	}
}
